Package: org.codehaus.groovy.antlr.java

## [Java] Class JavaRecognizer

- org.codehaus.groovy.antlr.java.JavaRecognizer

- All Implemented Interfaces and Traits:
    JavaTokenTypes

      public class JavaRecognizer
      extends LLkParser

  Java 1.5 Recognizer Run 'java Main [-showtree] directory-full-of-java-files' [The -showtree option pops up a Swing frame that shows the AST constructed from the parser.] Run 'java Main ' Contributing authors: Jeremy Rayner groovy@ross-rayner.com John Mitchell johnm

  non.net:
    Terence Parr parrt@magelang.com John Lilley jlilley@empathy.com Scott Stanchfield thetick@magelang.com Markus Mohnen mohnen@informatik.rwth-aachen.de Peter Williams pete.williams@sun.com Allan Jacobs Allan.Jacobs@eng.sun.com Steve Messick messick@redhills.com John Pybus john@pybus.org Version 1.00 December 9, 1997 -- initial release Version 1.01 December 10, 1997 fixed bug in octal def (0..7 not 0..8) Version 1.10 August 1998 (parrt) added tree construction fixed definition of WS,comments for mac,pc,unix newlines added unary plus Version 1.11 (Nov 20, 1998) Added "shutup" option to turn off last ambig warning. Fixed inner class def to allow named class defs as statements synchronized requires compound not simple statement add [] after builtInType DOT class in primaryExpression "const" is reserved but not valid..removed from modifiers Version 1.12 (Feb 2, 1999) Changed LITERAL_xxx to xxx in tree grammar. Updated java.g to use tokens {...} now for 2.6.0 (new feature). Version 1.13 (Apr 23, 1999) Didn't have (stat)? for else clause in tree parser. Didn't gen ASTs for interface extends. Updated tree parser too. Updated to 2.6.0. Version 1.14 (Jun 20, 1999) Allowed final/abstract on local classes. Removed local interfaces from methods Put instanceof precedence where it belongs...in relationalExpr It also had expr not type as arg; fixed it. Missing ! on SEMI in classBlock fixed: (expr) + "string" was parsed incorrectly (+ as unary plus). fixed: didn't like Object[].class in parser or tree parser Version 1.15 (Jun 26, 1999) Screwed up rule with instanceof in it. :( Fixed. Tree parser didn't like (expr).something; fixed. Allowed multiple inheritance in tree grammar. oops. Version 1.16 (August 22, 1999) Extending an interface built a wacky tree: had extra EXTENDS. Tree grammar didn't allow multiple superinterfaces. Tree grammar didn't allow empty var initializer: {} Version 1.17 (October 12, 1999) ESC lexer rule allowed 399 max not 377 max. java.tree.g didn't handle the expression of synchronized statements. Version 1.18 (August 12, 2001) Terence updated to Java 2 Version 1.3 by observing/combining work of Allan Jacobs and Steve Messick. Handles 1.3 src. Summary: o primary didn't include boolean.class kind of thing o constructor calls parsed explicitly now: see explicitConstructorInvocation o add strictfp modifier o missing objBlock after new expression in tree grammar o merged local class definition alternatives, moved after declaration o fixed problem with ClassName.super.field o reordered some alternatives to make things more efficient o long and double constants were not differentiated from int/float o whitespace rule was inefficient: matched only one char o add an examples directory with some nasty 1.3 cases o made Main.java use buffered IO and a Reader for Unicode support o supports UNICODE? Using Unicode charVocabulay makes code file big, but only in the bitsets at the end. I need to make ANTLR generate unicode bitsets more efficiently. Version 1.19 (April 25, 2002) Terence added in nice fixes by John Pybus concerning floating constants and problems with super() calls. John did a nice reorg of the primary/postfix expression stuff to read better and makes f.g.super() parse properly (it was METHOD_CALL not a SUPER_CTOR_CALL). Also: o "finally" clause was a root...made it a child of "try" o Added stuff for asserts too for Java 1.4, but *commented out* as it is not backward compatible. Version 1.20 (October 27, 2002) Terence ended up reorging John Pybus' stuff to remove some nondeterminisms and some syntactic predicates. Note that the grammar is stricter now; e.g., this(...) must be the first statement. Trinary ?: operator wasn't working as array name: (isBig ? bigDigits : digits)[i]; Checked parser/tree parser on source for Resin-2.0.5, jive-2.1.1, jdk 1.3.1, Lucene, antlr 2.7.2a4, and the 110k-line jGuru server source. Version 1.21 (October 17, 2003) Fixed lots of problems including: Ray Waldin: add typeDefinition to interfaceBlock in java.tree.g He found a problem/fix with floating point that start with 0 Ray also fixed problem that (int.class) was not recognized. Thorsten van Ellen noticed that \n are allowed incorrectly in strings. TJP fixed CHAR_LITERAL analogously. Version 1.21.2 (March, 2003) Changes by Matt Quail to support generics (as per JDK1.5/JSR14) Notes: o We only allow the "extends" keyword and not the "implements" keyword, since thats what JSR14 seems to imply. o Thanks to Monty Zukowski for his help on the antlr-interest mail list. o Thanks to Alan Eliasen for testing the grammar over his Fink source base Version 1.22 (July, 2004) Changes by Michael Studman to support Java 1.5 language extensions Notes: o Added support for annotations types o Finished off Matt Quail's generics enhancements to support bound type arguments o Added support for new for statement syntax o Added support for static import syntax o Added support for enum types o Tested against JDK 1.5 source base and source base of jdigraph project o Thanks to Matt Quail for doing the hard part by doing most of the generics work Version 1.22.1 (July 28, 2004) Bug/omission fixes for Java 1.5 language support o Fixed tree structure bug with classOrInterface - thanks to Pieter Vangorpto for spotting this o Fixed bug where incorrect handling of SR and BSR tokens would cause type parameters to be recognised as type arguments. o Enabled type parameters on constructors, annotations on enum constants and package definitions o Fixed problems when parsing if ((char.class.equals(c))) {} - solution by Matt Quail at Cenqua Version 1.22.2 (July 28, 2004) Slight refactoring of Java 1.5 language support o Refactored for/"foreach" productions so that original literal "for" literal is still used but the for sub-clauses vary by token type o Fixed bug where type parameter was not included in generic constructor's branch of AST Version 1.22.3 (August 26, 2004) Bug fixes as identified by Michael Stahl; clean up of tabs/spaces and other refactorings o Fixed typeParameters omission in identPrimary and newStatement o Replaced GT reconcilliation code with simple semantic predicate o Adapted enum/assert keyword checking support from Michael Stahl's java15 grammar o Refactored typeDefinition production and field productions to reduce duplication Version 1.22.4 (October 21, 2004) Small bux fixes o Added typeArguments to explicitConstructorInvocation, e.g. new MyParameterised() o Added typeArguments to postfixExpression productions for anonymous inner class super constructor invocation, e.g. new Outer().super() o Fixed bug in array declarations identified by Geoff Roy Version 1.22.4.j.1 Changes by Jeremy Rayner to support java2groovy tool o I have taken java.g for Java1.5 from Michael Studman (1.22.4) and have made some changes to enable use by java2groovy tool (Jan 2007) Based on an original grammar released in the PUBLIC DOMAIN

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static String[]` | `_tokenNames` |
    `static BitSet` | `_tokenSet_0` |
    `static BitSet` | `_tokenSet_1` |
    `static BitSet` | `_tokenSet_10` |
    `static BitSet` | `_tokenSet_11` |
    `static BitSet` | `_tokenSet_12` |
    `static BitSet` | `_tokenSet_13` |
    `static BitSet` | `_tokenSet_14` |
    `static BitSet` | `_tokenSet_15` |
    `static BitSet` | `_tokenSet_16` |
    `static BitSet` | `_tokenSet_17` |
    `static BitSet` | `_tokenSet_18` |
    `static BitSet` | `_tokenSet_19` |
    `static BitSet` | `_tokenSet_2` |
    `static BitSet` | `_tokenSet_20` |
    `static BitSet` | `_tokenSet_21` |
    `static BitSet` | `_tokenSet_22` |
    `static BitSet` | `_tokenSet_23` |
    `static BitSet` | `_tokenSet_24` |
    `static BitSet` | `_tokenSet_25` |
    `static BitSet` | `_tokenSet_26` |
    `static BitSet` | `_tokenSet_27` |
    `static BitSet` | `_tokenSet_28` |
    `static BitSet` | `_tokenSet_29` |
    `static BitSet` | `_tokenSet_3` |
    `static BitSet` | `_tokenSet_30` |
    `static BitSet` | `_tokenSet_31` |
    `static BitSet` | `_tokenSet_32` |
    `static BitSet` | `_tokenSet_33` |
    `static BitSet` | `_tokenSet_34` |
    `static BitSet` | `_tokenSet_35` |
    `static BitSet` | `_tokenSet_36` |
    `static BitSet` | `_tokenSet_37` |
    `static BitSet` | `_tokenSet_38` |
    `static BitSet` | `_tokenSet_39` |
    `static BitSet` | `_tokenSet_4` |
    `static BitSet` | `_tokenSet_40` |
    `static BitSet` | `_tokenSet_41` |
    `static BitSet` | `_tokenSet_42` |
    `static BitSet` | `_tokenSet_43` |
    `static BitSet` | `_tokenSet_44` |
    `static BitSet` | `_tokenSet_45` |
    `static BitSet` | `_tokenSet_46` |
    `static BitSet` | `_tokenSet_47` |
    `static BitSet` | `_tokenSet_48` |
    `static BitSet` | `_tokenSet_49` |
    `static BitSet` | `_tokenSet_5` |
    `static BitSet` | `_tokenSet_6` |
    `static BitSet` | `_tokenSet_7` |
    `static BitSet` | `_tokenSet_8` |
    `static BitSet` | `_tokenSet_9` |

  - ### Constructor Summary

    Constructors
    Constructor and description
    `protected JavaRecognizer (TokenBuffer tokenBuf, int k)`
    `JavaRecognizer (TokenBuffer tokenBuf)`
    `protected JavaRecognizer (TokenStream lexer, int k)`
    `JavaRecognizer (TokenStream lexer)`
    `JavaRecognizer (ParserSharedInputState state)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `void` | `aCase()`
    `` | `void` | `additiveExpression()`
    `` | `void` | `andExpression()`
    `` | `void` | `annotation()`
    `` | `void` | `annotationArguments()`
    `` | `void` | `annotationBlock()`
    `` | `void` | `annotationDefinition(AST modifiers)`
    `` | `void` | `annotationField()`
    `` | `void` | `annotationMemberArrayInitializer()`
    `` | `void` | `annotationMemberArrayValueInitializer()`
    `` | `void` | `annotationMemberValueInitializer()`
    `` | `void` | `annotationMemberValuePair()`
    `` | `void` | `annotations()`
    `` | `void` | `anntotationMemberValuePairs()`
    `` | `void` | `argList()`
    `` | `void` | `arrayInitializer()`
    `` | `void` | `assignmentExpression()`
    `` | `protected void` | `buildTokenTypeASTClassMap()`
    `` | `void` | `builtInType()`
    `` | `void` | `builtInTypeArraySpec(boolean addImagNode)`
    `` | `void` | `builtInTypeSpec(boolean addImagNode)`
    `` | `void` | `caseSList()`
    `` | `void` | `casesGroup()`
    `` | `void` | `classBlock()`
    `` | `void` | `classDefinition(AST modifiers)`
    `` | `void` | `classField()`
    `` | `void` | `classOrInterfaceType(boolean addImagNode)`
    `` | `void` | `classTypeSpec(boolean addImagNode)`
    `` | `void` | `compilationUnit()`
    `` | `void` | `compoundStatement()`
    `` | `void` | `conditionalExpression()`
    `` | `void` | `constant()`
    `` | `void` | `constructorBody()`
    `` | `AST` | `create(int type, String txt, Token first, Token last)` Create an AST node with the token type and text passed in, but with the same background information as another supplied Token (e.g. line numbers) to be used in place of antlr tree construction syntax, i.e.
    `` | `void` | `ctorHead()`
    `` | `void` | `declaration()`
    `` | `void` | `declaratorBrackets(AST typ)`
    `` | `void` | `enumBlock()`
    `` | `void` | `enumConstant()`
    `` | `void` | `enumConstantBlock()`
    `` | `void` | `enumConstantField()`
    `` | `void` | `enumDefinition(AST modifiers)`
    `` | `void` | `equalityExpression()`
    `` | `void` | `exclusiveOrExpression()`
    `` | `void` | `explicitConstructorInvocation()` Catch obvious constructor calls, but not the expr.super(...) calls
    `` | `void` | `expression()`
    `` | `void` | `expressionList()`
    `` | `void` | `finallyClause()`
    `` | `void` | `forCond()`
    `` | `void` | `forEachClause()`
    `` | `void` | `forInit()`
    `` | `void` | `forIter()`
    `` | `void` | `forStatement()`
    `` | `JavaLexer` | `getLexer()`
    `` | `void` | `handler()`
    `` | `void` | `identPrimary()` Match a, a.b.c refs, a.b.c(...) refs, a.b.c[], a.b.c[].class, and a.b.c.class refs.
    `` | `void` | `identifier()`
    `` | `void` | `identifierStar()`
    `` | `void` | `implementsClause()`
    `` | `void` | `importDefinition()`
    `` | `void` | `inclusiveOrExpression()`
    `` | `void` | `initializer()`
    `` | `void` | `interfaceBlock()`
    `` | `void` | `interfaceDefinition(AST modifiers)`
    `` | `void` | `interfaceExtends()`
    `` | `void` | `interfaceField()`
    `` | `void` | `logicalAndExpression()`
    `` | `void` | `logicalOrExpression()`
    `` | `static JavaRecognizer` | `make(JavaLexer lexer)` This factory is the correct way to wire together a Groovy parser and lexer.
    `` | `static JavaRecognizer` | `make(InputStream in)`
    `` | `static JavaRecognizer` | `make(Reader in)`
    `` | `static JavaRecognizer` | `make(InputBuffer in)`
    `` | `static JavaRecognizer` | `make(LexerSharedInputState in)`
    `` | `void` | `modifier()`
    `` | `void` | `modifiers()`
    `` | `void` | `multicatch()`
    `` | `void` | `multicatch_types()`
    `` | `void` | `multiplicativeExpression()`
    `` | `void` | `newArrayDeclarator()`
    `` | `void` | `newExpression()` object instantiation.
    `` | `void` | `packageDefinition()`
    `` | `void` | `parameterDeclaration()`
    `` | `void` | `parameterDeclarationList()`
    `` | `void` | `parameterModifier()`
    `` | `void` | `postfixExpression()`
    `` | `void` | `primaryExpression()`
    `` | `void` | `relationalExpression()`
    `` | `void` | `setFilename(String f)`
    `` | `void` | `setSourceBuffer(SourceBuffer sourceBuffer)`
    `` | `void` | `shiftExpression()`
    `` | `void` | `statement()`
    `` | `void` | `superClassClause()`
    `` | `void` | `throwsClause()`
    `` | `void` | `traditionalForClause()`
    `` | `void` | `tryBlock()`
    `` | `void` | `type()`
    `` | `void` | `typeArgument()`
    `` | `void` | `typeArgumentBounds()`
    `` | `void` | `typeArgumentSpec()`
    `` | `void` | `typeArguments()`
    `` | `void` | `typeArgumentsOrDiamond()`
    `` | `protected void` | `typeArgumentsOrParametersEnd()`
    `` | `void` | `typeDefinition()`
    `` | `protected void` | `typeDefinitionInternal(AST mods)`
    `` | `void` | `typeParameter()`
    `` | `void` | `typeParameterBounds()`
    `` | `void` | `typeParameters()`
    `` | `void` | `typeSpec(boolean addImagNode)`
    `` | `void` | `unaryExpression()`
    `` | `void` | `unaryExpressionNotPlusMinus()`
    `` | `void` | `varInitializer()`
    `` | `void` | `variableDeclarator(AST mods, AST t)` Declaration of a variable.
    `` | `void` | `variableDefinitions(AST mods, AST t)`
    `` | `void` | `variableLengthParameterDeclaration()`
    `` | `void` | `wildcardType()`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class LLkParser` | `LT, LA, traceOut, traceIn, consume, reportError, reportError, recover, getFilename, getTokenName, getTokenNames, getAST, setFilename, setTokenBuffer, addMessageListener, setDebugMode, isDebugMode, setASTNodeType, addTraceListener, setASTFactory, addParserListener, addParserTokenListener, addSyntacticPredicateListener, removeMessageListener, addSemanticPredicateListener, removeParserListener, removeParserTokenListener, addParserMatchListener, removeParserMatchListener, removeSemanticPredicateListener, removeSyntacticPredicateListener, removeTraceListener, setIgnoreInvalidDebugCalls, getTokenTypeToASTClassMap, consumeUntil, consumeUntil, matchNot, getInputState, setInputState, traceIndent, panic, reportWarning, setASTNodeClass, getASTFactory, match, match, mark, rewind, wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`
    `class Parser` | `reportError, reportError, recover, getFilename, LT, getTokenName, getTokenNames, getAST, setFilename, setTokenBuffer, addMessageListener, setDebugMode, isDebugMode, setASTNodeType, addTraceListener, setASTFactory, addParserListener, addParserTokenListener, addSyntacticPredicateListener, removeMessageListener, addSemanticPredicateListener, removeParserListener, removeParserTokenListener, addParserMatchListener, removeParserMatchListener, removeSemanticPredicateListener, removeSyntacticPredicateListener, removeTraceListener, setIgnoreInvalidDebugCalls, getTokenTypeToASTClassMap, LA, consumeUntil, consumeUntil, matchNot, getInputState, setInputState, traceIndent, traceOut, panic, reportWarning, traceIn, setASTNodeClass, getASTFactory, match, match, mark, rewind, consume, wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### public static final String[] _tokenNames

    - #### public static final BitSet _tokenSet_0

    - #### public static final BitSet _tokenSet_1

    - #### public static final BitSet _tokenSet_10

    - #### public static final BitSet _tokenSet_11

    - #### public static final BitSet _tokenSet_12

    - #### public static final BitSet _tokenSet_13

    - #### public static final BitSet _tokenSet_14

    - #### public static final BitSet _tokenSet_15

    - #### public static final BitSet _tokenSet_16

    - #### public static final BitSet _tokenSet_17

    - #### public static final BitSet _tokenSet_18

    - #### public static final BitSet _tokenSet_19

    - #### public static final BitSet _tokenSet_2

    - #### public static final BitSet _tokenSet_20

    - #### public static final BitSet _tokenSet_21

    - #### public static final BitSet _tokenSet_22

    - #### public static final BitSet _tokenSet_23

    - #### public static final BitSet _tokenSet_24

    - #### public static final BitSet _tokenSet_25

    - #### public static final BitSet _tokenSet_26

    - #### public static final BitSet _tokenSet_27

    - #### public static final BitSet _tokenSet_28

    - #### public static final BitSet _tokenSet_29

    - #### public static final BitSet _tokenSet_3

    - #### public static final BitSet _tokenSet_30

    - #### public static final BitSet _tokenSet_31

    - #### public static final BitSet _tokenSet_32

    - #### public static final BitSet _tokenSet_33

    - #### public static final BitSet _tokenSet_34

    - #### public static final BitSet _tokenSet_35

    - #### public static final BitSet _tokenSet_36

    - #### public static final BitSet _tokenSet_37

    - #### public static final BitSet _tokenSet_38

    - #### public static final BitSet _tokenSet_39

    - #### public static final BitSet _tokenSet_4

    - #### public static final BitSet _tokenSet_40

    - #### public static final BitSet _tokenSet_41

    - #### public static final BitSet _tokenSet_42

    - #### public static final BitSet _tokenSet_43

    - #### public static final BitSet _tokenSet_44

    - #### public static final BitSet _tokenSet_45

    - #### public static final BitSet _tokenSet_46

    - #### public static final BitSet _tokenSet_47

    - #### public static final BitSet _tokenSet_48

    - #### public static final BitSet _tokenSet_49

    - #### public static final BitSet _tokenSet_5

    - #### public static final BitSet _tokenSet_6

    - #### public static final BitSet _tokenSet_7

    - #### public static final BitSet _tokenSet_8

    - #### public static final BitSet _tokenSet_9

  - ### Constructor Detail

    - #### protected JavaRecognizer(TokenBuffer tokenBuf, int k)

    - #### public JavaRecognizer(TokenBuffer tokenBuf)

    - #### protected JavaRecognizer(TokenStream lexer, int k)

    - #### public JavaRecognizer(TokenStream lexer)

    - #### public JavaRecognizer(ParserSharedInputState state)

  - ### Method Detail

    - #### public final void aCase()

    - #### public final void additiveExpression()

    - #### public final void andExpression()

    - #### public final void annotation()

    - #### public final void annotationArguments()

    - #### public final void annotationBlock()

    - #### public final void annotationDefinition(AST modifiers)

    - #### public final void annotationField()

    - #### public final void annotationMemberArrayInitializer()

    - #### public final void annotationMemberArrayValueInitializer()

    - #### public final void annotationMemberValueInitializer()

    - #### public final void annotationMemberValuePair()

    - #### public final void annotations()

    - #### public final void anntotationMemberValuePairs()

    - #### public final void argList()

    - #### public final void arrayInitializer()

    - #### public final void assignmentExpression()

    - #### protected void buildTokenTypeASTClassMap()

    - #### public final void builtInType()

    - #### public final void builtInTypeArraySpec(boolean addImagNode)

    - #### public final void builtInTypeSpec(boolean addImagNode)

    - #### public final void caseSList()

    - #### public final void casesGroup()

    - #### public final void classBlock()

    - #### public final void classDefinition(AST modifiers)

    - #### public final void classField()

    - #### public final void classOrInterfaceType(boolean addImagNode)

    - #### public final void classTypeSpec(boolean addImagNode)

    - #### public final void compilationUnit()

    - #### public final void compoundStatement()

    - #### public final void conditionalExpression()

    - #### public final void constant()

    - #### public final void constructorBody()

    - #### public AST create(int type, String txt, Token first, Token last)

      Create an AST node with the token type and text passed in, but with the same background information as another supplied Token (e.g. line numbers) to be used in place of antlr tree construction syntax, i.e. #[TOKEN,"text"] becomes create(TOKEN,"text",anotherToken) todo - change antlr.ASTFactory to do this instead...

    - #### public final void ctorHead()

    - #### public final void declaration()

    - #### public final void declaratorBrackets(AST typ)

    - #### public final void enumBlock()

    - #### public final void enumConstant()

    - #### public final void enumConstantBlock()

    - #### public final void enumConstantField()

    - #### public final void enumDefinition(AST modifiers)

    - #### public final void equalityExpression()

    - #### public final void exclusiveOrExpression()

    - #### public final void explicitConstructorInvocation()

      Catch obvious constructor calls, but not the expr.super(...) calls

    - #### public final void expression()

    - #### public final void expressionList()

    - #### public final void finallyClause()

    - #### public final void forCond()

    - #### public final void forEachClause()

    - #### public final void forInit()

    - #### public final void forIter()

    - #### public final void forStatement()

    - #### public JavaLexer getLexer()

    - #### public final void handler()

    - #### public final void identPrimary()

      Match a, a.b.c refs, a.b.c(...) refs, a.b.c[], a.b.c[].class, and a.b.c.class refs. Also this(...) and super(...). Match this or super.

    - #### public final void identifier()

    - #### public final void identifierStar()

    - #### public final void implementsClause()

    - #### public final void importDefinition()

    - #### public final void inclusiveOrExpression()

    - #### public final void initializer()

    - #### public final void interfaceBlock()

    - #### public final void interfaceDefinition(AST modifiers)

    - #### public final void interfaceExtends()

    - #### public final void interfaceField()

    - #### public final void logicalAndExpression()

    - #### public final void logicalOrExpression()

    - #### public static JavaRecognizer make(JavaLexer lexer)

      This factory is the correct way to wire together a Groovy parser and lexer.

    - #### public static JavaRecognizer make(InputStream in)

    - #### public static JavaRecognizer make(Reader in)

    - #### public static JavaRecognizer make(InputBuffer in)

    - #### public static JavaRecognizer make(LexerSharedInputState in)

    - #### public final void modifier()

    - #### public final void modifiers()

    - #### public final void multicatch()

    - #### public final void multicatch_types()

    - #### public final void multiplicativeExpression()

    - #### public final void newArrayDeclarator()

    - #### public final void newExpression()

      object instantiation. Trees are built as illustrated by the following input/tree pairs: new T() new | T -- ELIST | arg1 -- arg2 -- .. -- argn new int[] new | int -- ARRAY_DECLARATOR new int[] {1,2} new | int -- ARRAY_DECLARATOR -- ARRAY_INIT | EXPR -- EXPR | | 1 2 new int[3] new | int -- ARRAY_DECLARATOR | EXPR | 3 new int[1][2] new | int -- ARRAY_DECLARATOR | ARRAY_DECLARATOR -- EXPR | | EXPR 1 | 2

    - #### public final void packageDefinition()

    - #### public final void parameterDeclaration()

    - #### public final void parameterDeclarationList()

    - #### public final void parameterModifier()

    - #### public final void postfixExpression()

    - #### public final void primaryExpression()

    - #### public final void relationalExpression()

    - #### public void setFilename(String f)

    - #### public void setSourceBuffer(SourceBuffer sourceBuffer)

    - #### public final void shiftExpression()

    - #### public final void statement()

    - #### public final void superClassClause()

    - #### public final void throwsClause()

    - #### public final void traditionalForClause()

    - #### public final void tryBlock()

    - #### public final void type()

    - #### public final void typeArgument()

    - #### public final void typeArgumentBounds()

    - #### public final void typeArgumentSpec()

    - #### public final void typeArguments()

    - #### public final void typeArgumentsOrDiamond()

    - #### protected final void typeArgumentsOrParametersEnd()

    - #### public final void typeDefinition()

    - #### protected final void typeDefinitionInternal(AST mods)

    - #### public final void typeParameter()

    - #### public final void typeParameterBounds()

    - #### public final void typeParameters()

    - #### public final void typeSpec(boolean addImagNode)

    - #### public final void unaryExpression()

    - #### public final void unaryExpressionNotPlusMinus()

    - #### public final void varInitializer()

    - #### public final void variableDeclarator(AST mods, AST t)

      Declaration of a variable. This can be a class/instance variable, or a local variable in a method It can also include possible initialization.

    - #### public final void variableDefinitions(AST mods, AST t)

    - #### public final void variableLengthParameterDeclaration()

    - #### public final void wildcardType()